#-----------------------------------------------------
# Scene_Album
# アルバムのシーンクラス
#-----------------------------------------------------
class Scene_Album < Scene_Base
  # 初期化
  def initialize(*ext)
    @display_flg = false
    @delete_flg = false
    @sprite_album = nil
    create_image
    super
    create_background
  end
  # 全てのウィンドウを作成
  def create_all_windows
    super
    create_help_window
    create_album_window
  end
  # ヘルプウィンドウの作成
  def create_help_window
    @windows[:help] = Window_Help.new(25, 573, 1233, 135)
  end
  # アルバムの作成
  def create_album_window
    @windows[:album] = Window_Album.new(47,119,480,400)
    @windows[:album].set_handler(:ok, method(:album_ok))
    @windows[:album].set_handler(:cancel, method(:album_cancel))
    @windows[:album].up_down_img_xy(260,113,260,527)
    @windows[:album].display_up_down = true
    @windows[:album].set_thumb(@sprite_album)
    @windows[:album].help_window = @windows[:help]
    @windows[:album].refresh
    @windows[:album].active
  end
  # 一枚絵表示スプライトを作成
  def create_image
    @sprite_album = Sprite_Base.new(571, 142)
    @sprite_album.center_x = 0
    @sprite_album.center_y = 0
    @sprite_album.scale_x = 0.5
    @sprite_album.scale_y = 0.5
  end
  # 背景を作成
  def create_background
    @bg= Sprite_Pis.new("data/img/menu/album.pis", 0, 0)
  end
  # 一枚絵選択
  def album_ok
    @display_flg = true
    @windows[:album].deactive
    VEffect.load_picture(@windows[:album].item)
    VEffect.show_picture(30, 255)
  end
  # アルバムキャンセル
  def album_cancel
    SceneManager.return
  end
  # 更新
  def update
    @bg.update
    @bg.draw
    @sprite_album.draw
    hide_pic if @display_flg && Key.push?(:cancel) && !VEffect.picture_infade?
    delete_pic if @delete_flg && !VEffect.picture_infade?
    super
  end
  # 一枚絵フェードアウト
  def hide_pic
    VEffect.hide_picture(30)
    @display_flg = false
    @delete_flg = true
  end
  # 一枚絵削除
  def delete_pic
    VEffect.delete_picture
    @delete_flg = false
    @windows[:album].active
  end
  # 解放
  def dispose
    super
    @sprite_album.dispose
    @sprite_album = nil
    @bg.dispose
    @bg = nil
  end
end
