#-----------------------------------------------------
# Scene_RecollectRoom
# CGと敗北回想の視聴を行うシーンクラス
#-----------------------------------------------------
class Scene_RecollectRoom < Scene_Base
  # 初期化
  def initialize(*ext)
    @image_enemy = nil
    @sprite_enemy = nil
    create_image
    super
    @cg_or_event = :cg
    @position = 0
    @wear = 0
    @pant = 0
    @mode = :collect
    create_background
    create_situaion_bg
  end
  # 全てのウィンドウを作成
  def create_all_windows
    super
    create_help_window
    create_cg_event_window
    create_enemy_list
    create_narrow_window
    create_operation_guide
    create_collect_position_window
    create_force_position_window
    create_wear_window
    create_pant_window
  end
  # 絞込み内容ウィンドウを作成
  def create_help_window
    @windows[:help] = Window_Help.new(25, 573, 1233, 135)
  end
  # CG or EVENT 選択ウィンドウを作成
  def create_cg_event_window
    @windows[:menu] = Window_CGorEVENT.new(252, 26)
    @windows[:menu].add_command("", :battle, method(:select_cg))
    @windows[:menu].add_command("", :recollect, method(:select_event))
    @windows[:menu].set_handler(:cancel, method(:reco_cancel))
    @windows[:menu].help_window = @windows[:help]
    @windows[:menu].active
    @windows[:menu].refresh
  end
  # 敵リストを作成
  def create_enemy_list
    @windows[:enemy] = Window_EnemyList.new(65,116,404,343)
    @windows[:enemy].set_handler(:ok, method(:recollect_ok))
    @windows[:enemy].set_handler(:cancel, method(:recollect_cancel))
    @windows[:enemy].set_handler(:favorite, method(:recollect_favorite))
    @windows[:enemy].set_handler(:narrow, method(:recollect_narrow))
    @windows[:enemy].set_handler(:bgm, method(:recollect_bgm))
    @windows[:enemy].help_window = @windows[:help]
    @windows[:enemy].enemy_image(@sprite_enemy, @image_enemy)
    @windows[:enemy].up_down_img_xy(270,112,270,458)
    @windows[:enemy].display_up_down = true
    @windows[:enemy].scene = :recollect
    @windows[:enemy].deactive
  end
  # 絞り込みウィンドウを作成
  def create_narrow_window
    @windows[:narrow] = Window_Narrow.new(65,123,480,332)
    @windows[:narrow].set_handler(:cancel, method(:narrow_cancel))
    @windows[:narrow].help_window = @windows[:help]
    @windows[:narrow].visible = false
    @windows[:narrow].up_down_img_xy(270,112,270,458)
    @windows[:narrow].display_up_down = true
    @windows[:narrow].deactive
    @windows[:narrow].refresh
  end
  # 操作説明
  def create_operation_guide
    @guide = Sprite_Base.new(65, 490)
    @guide.image = Image_Message.new(1233, 32)
    @guide.image.default_size = 32
    unless $system.game_clear
      @guide.image.draw_text(0, 0, Vocab::RecRoomGuide)
    else
      @guide.image.draw_text(0, 0, Vocab::RecRoomGuide + "　Wキー：サウンドテスト起動")
    end
  end
  # 体位を設定するウィンドウの作成（データ採集モード）
  def create_collect_position_window
    @windows[:col_position] = Window_HorzCommand.new(500, 360)
    @windows[:col_position].add_command("    通常", :normal,   method(:set_collect_position_normal))
    @windows[:col_position].add_command("    拘束", :restrict, method(:set_collect_position_restrict))
    @windows[:col_position].set_handler(:cancel, method(:position_cancel))
    @windows[:col_position].visible = false
    @windows[:col_position].deactive
    @windows[:col_position].refresh
  end
  # 体位を設定するウィンドウの作成（武力行使モード）
  def create_force_position_window
    @windows[:for_position] = Window_Command.new(570, 330, 138)
    @windows[:for_position].add_command("通常戦闘", :normal,   method(:set_force_position_normal))
    @windows[:for_position].add_command("性技戦闘", :sex, method(:set_force_position_sex))
    @windows[:for_position].add_command("　陵辱", :restrict, method(:set_force_position_restrict))
    @windows[:for_position].set_handler(:cancel, method(:position_cancel))
    @windows[:for_position].visible = false
    @windows[:for_position].deactive
    @windows[:for_position].refresh
  end
  # 衣服を設定するウィンドウの作成
  def create_wear_window
    @windows[:wear] = Window_HorzCommand.new(500, 360)
    @windows[:wear].add_command("  衣服あり", :normal, method(:set_wear_normal))
    @windows[:wear].add_command("  衣服なし", :break,  method(:set_wear_break))
    @windows[:wear].set_handler(:cancel, method(:wear_cancel))
    @windows[:wear].visible = false
    @windows[:wear].deactive
    @windows[:wear].refresh
  end
  # パンツを設定するウィンドウの作成
  def create_pant_window
    @windows[:pant] = Window_HorzCommand.new(500, 360)
    @windows[:pant].add_command("  パンツあり", :normal, method(:set_pant_normal))
    @windows[:pant].add_command("  パンツなし", :none,   method(:set_pant_none))
    @windows[:pant].set_handler(:cancel, method(:pant_cancel))
    @windows[:pant].visible = false
    @windows[:pant].deactive
    @windows[:pant].refresh
  end
  #キャラのイメージを作成
  def create_image
    @sprite_enemy = Sprite_Base.new(608.5, 126)
    @image_enemy = Pis.load($game_directory + '/data/img/menu/enemies.pis')
  end
  # 背景を作成
  def create_background
    @bg= Sprite_Pis.new("data/img/menu/recollect.pis", 0, 0)
    @sprite_enemy.z = @bg.z + 2
  end
  # シチュエーション背景を作成
  def create_situaion_bg
    @situ_bg= Sprite_Pis.new("data/img/menu/situation.pis", 444.5, 256)
    @situ_bg.z = @windows[:enemy].z + 2
    @windows[:col_position].z = @situ_bg.z + 2
    @windows[:for_position].z = @situ_bg.z + 2
    @windows[:wear].z = @situ_bg.z + 2
    @windows[:pant].z = @situ_bg.z + 2
  end
  # 選択＞キャンセル
  def reco_cancel
    SceneManager.return
  end
  # 選択＞選択時基本処理
  def select_basic
    @windows[:menu].deactive
    @windows[:enemy].cg_or_event = @cg_or_event
    @windows[:enemy].active
    @windows[:enemy].visible = true
    @windows[:enemy].refresh
  end
  # 選択＞CGを選択
  def select_cg
    @cg_or_event = :cg
    select_basic
  end
  # メニュー＞回想を選択
  def select_event
    @cg_or_event = :event
    select_basic
  end
  # CGへ移行
  def goto_cg
    VEffect.start_draw_loading
    SceneManager.call(Scene_CG,
      :black,
      @windows[:enemy].item,
      @position,
      @wear,
      @pant
    )
  end
  # 敗北回想へ移行
  def goto_recollect
    VEffect.start_draw_loading
    SceneManager.call(Scene_Recollect,
      :black,
      @windows[:enemy].item,
      @position,
      @wear,
      @pant
    )
  end
  # 敵リスト(回想)の決定
  def recollect_ok
    Audio.play_ok
    @mode = Data_Enemy.system(@windows[:enemy].item)
    if Data_Enemy.not_enemy?(@windows[:enemy].item) || Data_Enemy.cg_only?(@windows[:enemy].item)
      @position = 0
      @wear = 0
      @pant = 0
      case @cg_or_event
      when :cg    ; goto_cg
      when :event ; goto_recollect
      end
    else
      if @cg_or_event == :cg && @mode == :force
        @windows[:for_position].visible = true
        @windows[:enemy].deactive
        @windows[:for_position].active
      else
        @windows[:col_position].visible = true
        @windows[:enemy].deactive
        @windows[:col_position].active
      end
    end
  end
  # 敵リスト(回想)のキャンセル
  def recollect_cancel
    Audio.play_cancel
    @sprite_enemy.image = nil
    @windows[:enemy].deactive
    @windows[:menu].active
  end
  # お気に入り
  def recollect_favorite
    if $system.favo_recollect.include?(@windows[:enemy].item)
      Audio.play_cancel
      $system.favo_recollect.delete(@windows[:enemy].item)
      @windows[:enemy].refresh
    else
      Audio.play_ok
      $system.favo_recollect << @windows[:enemy].item
      @windows[:enemy].refresh
    end
  end
  # 絞り込みウィンドウ
  def recollect_narrow
    Audio.play_ok
    @windows[:enemy].visible = false
    @windows[:enemy].deactive
    @windows[:narrow].visible = true
    @windows[:narrow].active
  end
  # 絞り込みウィンドウキャンセル
  def narrow_cancel
    Audio.play_cancel
    @windows[:enemy].refresh
    @windows[:narrow].visible = false
    @windows[:narrow].deactive
    @windows[:enemy].visible = true
    @windows[:enemy].active
  end
  # サウンドテスト起動
  def recollect_bgm
    Audio.play_ok
    SceneManager.call(Scene_Jukebox)
  end
  # 体位設定＞「通常」（データ採集）
  def set_collect_position_normal
    Audio.play_ok
    position_ok
    @position = @mode == :collect ? 0 : 1
  end
  # 体位設定＞「拘束」（データ採集）
  def set_collect_position_restrict
    Audio.play_ok
    position_ok
    @position = @mode == :collect ? 1 : 2
  end
  # 体位設定＞「通常戦闘」（武力行使）
  def set_force_position_normal
    Audio.play_ok
    position_ok
    @position = 0
  end
  # 体位設定＞「性技戦闘」（武力行使）
  def set_force_position_sex
    Audio.play_ok
    position_ok
    @position = 1
  end
  # 体位設定＞「陵辱」（武力行使）
  def set_force_position_restrict
    Audio.play_ok
    position_ok
    @position = 2
  end
  # 体位設定＞決定
  def position_ok
    Audio.play_ok
    if @cg_or_event == :cg && @mode == :force
      @windows[:for_position].deactive
      @windows[:for_position].visible = false
    else
      @windows[:col_position].deactive
      @windows[:col_position].visible = false
    end
    @windows[:wear].active
    @windows[:wear].visible = true
  end
  # 体位設定＞キャンセル
  def position_cancel
    Audio.play_cancel
    if @cg_or_event == :cg && @mode == :force
      @windows[:for_position].visible = false
      @windows[:for_position].deactive
    else
      @windows[:col_position].visible = false
      @windows[:col_position].deactive
    end
    @windows[:enemy].active
  end
  # 衣服設定＞「衣服あり」
  def set_wear_normal
    Audio.play_ok
    @wear = 0
    wear_ok
  end
  # 衣服設定＞「衣服無し」
  def set_wear_break
    Audio.play_ok
    @wear = 1
    wear_ok
  end
  # 衣服設定＞決定
  def wear_ok
    Audio.play_ok
    @windows[:wear].deactive
    @windows[:wear].visible = false
    case @wear
    when 0
      @pant = 0
      pant_ok
    when 1
      @windows[:pant].active
      @windows[:pant].visible = true
    end
  end
  # 衣服設定＞キャンセル
  def wear_cancel
    Audio.play_cancel
    @windows[:wear].deactive
    @windows[:wear].visible = false
    if @cg_or_event == :cg && @mode == :force
      @windows[:for_position].active
      @windows[:for_position].visible = true
    else
      @windows[:col_position].active
      @windows[:col_position].visible = true
    end
  end
  # パンツ設定＞「パンツあり」
  def set_pant_normal
    Audio.play_ok
    @pant = 0
    pant_ok
  end
  # パンツ設定＞「パンツなし」
  def set_pant_none
    Audio.play_ok
    @pant = 1
    pant_ok
  end
  # パンツ設定＞決定
  def pant_ok
    Audio.play_ok
    @windows[:pant].deactive
    @windows[:pant].visible = false
    @windows[:enemy].active
    case @cg_or_event
    when :cg    ; goto_cg
    when :event ; goto_recollect
    end
  end
  # パンツ設定＞キャンセル
  def pant_cancel
    Audio.play_cancel
    @windows[:wear].active
    @windows[:wear].visible = true
    @windows[:pant].deactive
    @windows[:pant].visible = false
  end
  # 更新
  def update
    @sprite_enemy.draw if !@sprite_enemy.nil?
    @bg.update
    @bg.draw
    @guide.update
    @guide.draw
    if @windows[:col_position].active? || @windows[:for_position].active? || @windows[:wear].active? || @windows[:pant].active?
      @situ_bg.update
      @situ_bg.draw
    end
    super
  end
  # 解放処理
  def dispose
    super
    @sprite_enemy.image.dispose rescue nil
    @sprite_enemy.dispose
    @sprite_enemy.vanish
    @image_enemy.each{|enemy| enemy.dispose}
    @bg.dispose
    @guide.image.dispose
    @guide.dispose
    @guide.vanish
    @situ_bg.dispose
    @sprite_enemy = nil
    @image_enemy = nil
    @bg = nil
    @guide = nil
    @situ_bg = nil
  end
end
