﻿#-----------------------------------------------------
# class Window_MenuConfig
# メニュー画面のコンフィグを表示するウィンドウクラス。
#-----------------------------------------------------

class Window_MenuConfig < Window_Selectable
  # 行の高さ
  def line_height
    return 25
  end
  # ウィンドウ高さの取得
  def window_height
    return 327
  end
  # 項目数の最大値の取得
  def item_max
    return 16
  end
  # keyウィンドウの設定
  def key_window(instance)
    @key_window = instance
  end
  # 項目の描画
  def draw_item(index, rect_x, rect_y)
    case index
    when 0    # ＢＧＭ音量
      draw_text(rect_x, rect_y, "ＢＧＭ音量")
      text = $system.bgm_volume == 0 ? "ミュート" : sprintf("%d%%", $system.bgm_volume)
    when 1    # ＳＥ音量
      draw_text(rect_x, rect_y, "ＳＥ音量")
      text = $system.se_volume == 0 ? "ミュート" : sprintf("%d%%", $system.se_volume)
    when 2    # 戦闘SE音量
      draw_text(rect_x, rect_y, "戦闘SE音量")
      text = $system.moan_volume == 0 ? "ミュート" : sprintf("%d%%", $system.moan_volume)
    when 3    # 敗北シーン
      draw_text(rect_x, rect_y, "敗北シーン")
      case $system.lose_scene
      when 1
        text = "ON"
      when 2
        text = "OFF"
      when 3
        text = "毎回選択"
      end
    when 4    # オートメッセージ
      draw_text(rect_x, rect_y, "オートメッセージ")
      text = $system.auto_message ? "ON" : "OFF"
    when 5    # 会話メッセージ速度
      draw_text(rect_x, rect_y, "会話メッセージ速度")
      case $system.message_speed
      when 1
        text = "低速"
      when 2
        text = "中速"
      when 3
        text = "高速"
      when 4
        text = "瞬時"
      end
    when 6    # 戦闘メッセージ速度
      draw_text(rect_x, rect_y, "戦闘メッセージ速度")
      case $system.battle_speed
      when 1
        text = "低速"
      when 2
        text = "中速"
      when 3
        text = "高速"
      when 4
        text = "瞬時"
      end
    when 7    # アニメーション
      draw_text(rect_x, rect_y, "戦闘アニメーション")
      text = $system.animation ? "ON" : "OFF"
    when 8    # カットイン
      draw_text(rect_x, rect_y, "カットイン")
      text = $system.cut_in ? "ON" : "OFF"
    when 9    # 敗北回想中オノマトペ
      draw_text(rect_x, rect_y, "敗北回想中オノマトペ")
      text = $system.rec_onom ? "ON" : "OFF"
    when 10    # カーソル移動速度
      draw_text(rect_x, rect_y, "カーソル移動速度")
      case $system.cursor_speed
      when 1
        text = "低速"
      when nil, 2
        text = "中速"
      when 3
        text = "高速"
      end
    when 11    # マップ歩行方式
      $system.walk_dir = 1 if $system.walk_dir.nil?
      draw_text(rect_x, rect_y, "マップ歩行方式")
      case $system.walk_dir
      when 1
        text = "通常"
      when 2
        text = "右斜め"
      when 3
        text = "左斜め"
      end
    when 12    # 全画面表示
      draw_text(rect_x, rect_y, "全画面表示")
      text = $game_window_fullscreen ? "ON" : "OFF"
    when 13    # 戦闘前プラグイン設定
      draw_text(rect_x, rect_y, "戦闘前プラグイン設定")
      case $system.battle_setplugin
      when 1
        text = "ON"
      when 2
        text = "OFF"
      when 3
        text = "毎回選択"
      end
    when 14    # HLAグラフにヒントを表示
      draw_text(rect_x, rect_y, "戦闘前敵HLA表示")
      text = $system.setplugin_hla ? "ON" : "OFF"
    when 15    # キーコンフィグ
      draw_text(rect_x, rect_y, "キーコンフィグ")
      text = ""
    end
    draw_text(rect_x+400, rect_y, sprintf("%s", text), :color => [50, 190, 70])
  end
  # 決定ハンドラの呼び出し
  def process_ok
    case index
    when 0
      $system.bgm_volume += 20
      $system.bgm_volume = 0 if $system.bgm_volume > 100
      Audio.set_init_volume
    when 1
      $system.se_volume += 20
      $system.se_volume = 0 if $system.se_volume > 100
      Audio.set_init_volume
    when 2
      $system.moan_volume += 20
      $system.moan_volume = 0 if $system.moan_volume > 100
      Audio.set_init_volume
    when 3
      $system.lose_scene += 1
      $system.lose_scene = 1 if $system.lose_scene > 3
    when 4
      $system.auto_message ^= true
    when 5
      $system.message_speed += 1
      $system.message_speed = 1 if $system.message_speed > 4
    when 6
      $system.battle_speed += 1
      $system.battle_speed = 1 if $system.battle_speed > 4
    when 7
      $system.animation ^= true
    when 8
      $system.cut_in ^= true
    when 9
      $system.rec_onom ^= true
    when 10
      $system.cursor_speed += 1
      $system.cursor_speed = 1 if $system.cursor_speed > 3
    when 11
      $system.walk_dir += 1
      $system.walk_dir = 1 if $system.walk_dir > 3
    when 12
      $game_window_fullscreen ^= true
      $system.walk_dir = 1 if $system.walk_dir > 3
      # 全画面表示の設定を保存
      FileUtils.touch("data/bin/system/fullscreen") unless FileTest.exist?("data/bin/system/fullscreen")
      File.open("data/bin/system/fullscreen", "wb") do |file|
        Marshal.dump($game_window_fullscreen, file)
      end
      #----------------------
      Window.full_screen = $game_window_fullscreen
    when 13
      if $game_switches[9996]
        $system.battle_setplugin += 1
        $system.battle_setplugin = 1 if $system.battle_setplugin > 3
      else
        Audio.play_buzzer
      end
    when 14
      if $game_switches[9996]
        $system.setplugin_hla ^= true
      else
        Audio.play_buzzer
      end
    when 15
      @visible = false
      deactive
      @key_window.visible = true
      @key_window.active
    end
    super
    refresh
  end
  # カーソルを下に移動
  def cursor_down
    if row < row_max - 1
      select(@index + col_max)
    else
      select(0)
    end
  end
  # カーソルを上に移動
  def cursor_up
    if row + 1 > 1
      select(@index - col_max)
    else
      select(item_max)
    end
  end
  # ヘルプウィンドウの更新
  def update_help
    case index
    when 0; @help_window.set_text("BGM音量を調整します")
    when 1; @help_window.set_text("SE音量を調整します")
    when 2; @help_window.set_text("戦闘SE音量を調整します")
    when 3; @help_window.set_text("敗北時のイベントシーンをON/OFFできます\n毎回選択に設定すると、敗北するたびに選択できます")
    when 4; @help_window.set_text("会話メッセージの自動送りをON/OFFできます")
    when 5; @help_window.set_text("会話メッセージの速度を変更できます")
    when 6; @help_window.set_text("戦闘メッセージの速度を変更できます")
    when 7; @help_window.set_text("戦闘時のアニメーションをON/OFFできます")
    when 8; @help_window.set_text("カットインをON/OFFできます")
    when 9; @help_window.set_text("敗北回想中のオノマトペをON/OFFできます")
    when 10; @help_window.set_text("カーソルを長押しした時の移動速度を変更できます")
    when 11; @help_window.set_text("マップ歩行時の移動方向を設定します\n矢印キーを同時押ししなくても斜め移動が可能になります")
    when 12; @help_window.set_text("全画面表示を切り替えます\n（F11キーでも切り替え可能）")
    when 13
      if $game_switches[9996]
        @help_window.set_text("戦闘前にプラグイン設定画面を開きます\n必要のない場合はOFFにしてください")
      else
        @help_window.set_text("現在設定不可")
      end
    when 14
      if $game_switches[9996]
        @help_window.set_text("戦闘前のプラグイン設定画面で\n敵HLAの表示をON/OFFできます\n（赤いグラフで表示されます）")
      else
        @help_window.set_text("現在設定不可")
      end
    when 15; @help_window.set_text("キーコンフィグをカスタマイズできます")
    end
  end
end
