#-----------------------------------------------------
# class Window_PluginItem
# プラグイン画面のプラグインアイテムを表示するウィンドウクラス。
#-----------------------------------------------------

class Window_PluginItem < Window_MenuItem
  attr_accessor :slot_index
  # オブジェクト初期化
  def initialize(x, y, width, height)
    @slot_index = 0
    @quantity = 0
    @itemlist = []
    super
    make_item_list
  end
  # 行の高さ
  def line_height
    return 25
  end
  # 項目数の最大値の取得
  def item_max
    return [@itemlist.size, 1].max
  end
  # アイテムをリストに含めるかどうか
  def include?(item_id)
    match_ary = []
    $system.plugin_narrow.each{|key, val|
      next if val == 0 || key == :a_o
      case key
      when :hla
        case val
        when 1 ; match_ary << ((Data_Plugin.type(item_id) == :h) && (Data_Plugin.gravity(item_id) > 0))
        when 2 ; match_ary << ((Data_Plugin.type(item_id) == :h) && (Data_Plugin.gravity(item_id) < 0))
        when 3 ; match_ary << ((Data_Plugin.type(item_id) == :l) && (Data_Plugin.gravity(item_id) > 0))
        when 4 ; match_ary << ((Data_Plugin.type(item_id) == :l) && (Data_Plugin.gravity(item_id) < 0))
        when 5 ; match_ary << ((Data_Plugin.type(item_id) == :a) && (Data_Plugin.gravity(item_id) > 0))
        when 6 ; match_ary << ((Data_Plugin.type(item_id) == :a) && (Data_Plugin.gravity(item_id) < 0))
        when 7 ; match_ary << ((Data_Plugin.type(item_id) == :normal) || (Data_Plugin.gravity(item_id) == 0))
        end
      when :skill
        case val
        when 1 ; match_ary << (Data_Plugin.skill(item_id) > 0)
        when 2 ; match_ary << (Data_Plugin.skill(item_id) == 0)
        end
      when :org
        find_flg = false
        Data_Plugin.buffs(item_id).each{|ary|
          if ary[0] == :mhp
            find_flg = true
            case val
            when 1 ; match_ary << (ary[1] > 0)
            when 2 ; match_ary << (ary[1] < 0)
            end
          end
        }
        match_ary << false unless find_flg
      when :sp
        find_flg = false
        Data_Plugin.buffs(item_id).each{|ary|
          if ary[0] == :mep
            find_flg = true
            case val
            when 1 ; match_ary << (ary[1] > 0)
            when 2 ; match_ary << (ary[1] < 0)
            end
          end
        }
        match_ary << false unless find_flg
      when :tec
        find_flg = false
        Data_Plugin.buffs(item_id).each{|ary|
          if ary[0] == :tec
            find_flg = true
            case val
            when 1 ; match_ary << (ary[1] > 0)
            when 2 ; match_ary << (ary[1] < 0)
            end
          end
        }
        match_ary << false unless find_flg
      when :mnd
        find_flg = false
        Data_Plugin.buffs(item_id).each{|ary|
          if ary[0] == :mnd
            find_flg = true
            case val
            when 1 ; match_ary << (ary[1] > 0)
            when 2 ; match_ary << (ary[1] < 0)
            end
          end
        }
        match_ary << false unless find_flg
      when :agi
        find_flg = false
        Data_Plugin.buffs(item_id).each{|ary|
          if ary[0] == :agi
            find_flg = true
            case val
            when 1 ; match_ary << (ary[1] > 0)
            when 2 ; match_ary << (ary[1] < 0)
            end
          end
        }
        match_ary << false unless find_flg
      when :luk
        find_flg = false
        Data_Plugin.buffs(item_id).each{|ary|
          if ary[0] == :luk
            find_flg = true
            case val
            when 1 ; match_ary << (ary[1] > 0)
            when 2 ; match_ary << (ary[1] < 0)
            end
          end
        }
        match_ary << false unless find_flg
      when :atk
        find_flg = false
        Data_Plugin.buffs(item_id).each{|ary|
          if ary[0] == :atk
            find_flg = true
            case val
            when 1 ; match_ary << (ary[1] > 0)
            when 2 ; match_ary << (ary[1] < 0)
            end
          end
        }
        match_ary << false unless find_flg
      when :dfn
        find_flg = false
        Data_Plugin.buffs(item_id).each{|ary|
          if ary[0] == :dfn
            find_flg = true
            case val
            when 1 ; match_ary << (ary[1] > 0)
            when 2 ; match_ary << (ary[1] < 0)
            end
          end
        }
        match_ary << false unless find_flg
      when :charm
        find_flg = false
        Data_Plugin.resistance(item_id).each{|ary|
          if ary[0] == 5
            find_flg = true
            case val
            when 1 ; match_ary << (ary[1] > 0)
            when 2 ; match_ary << (ary[1] < 0)
            end
          end
        }
        match_ary << false unless find_flg
      when :palsy
        find_flg = false
        Data_Plugin.resistance(item_id).each{|ary|
          if ary[0] == 7
            find_flg = true
            case val
            when 1 ; match_ary << (ary[1] > 0)
            when 2 ; match_ary << (ary[1] < 0)
            end
          end
        }
        match_ary << false unless find_flg
      when :rest
        find_flg = false
        Data_Plugin.resistance(item_id).each{|ary|
          if ary[0] == 8
            find_flg = true
            case val
            when 1 ; match_ary << (ary[1] > 0)
            when 2 ; match_ary << (ary[1] < 0)
            end
          end
        }
        match_ary << false unless find_flg
      when :stan
        find_flg = false
        Data_Plugin.resistance(item_id).each{|ary|
          if ary[0] == 10
            find_flg = true
            case val
            when 1 ; match_ary << (ary[1] > 0)
            when 2 ; match_ary << (ary[1] < 0)
            end
          end
        }
        match_ary << false unless find_flg
      end
    }
    if match_ary == []
      return true
    else
      case $system.plugin_narrow[:a_o]
      when 0 ; return match_ary.all?
      when 1 ; return match_ary.any?
      end
    end
  end
  # 有効状態
  def enabled?(item_id)
    if caller[0][/`([^']*)'/, 1] == "item"
      return false if $player.equip_plugin[@slot_index] == item_id
      return false if @itemlist[index][1] - equip_count(@itemlist[index][0]) < 1
      return true
    end
    return false if @quantity < 1
    return true
  end
  # 装備カウント
  def equip_count(item_id)
    count = 0
    $player.equip_plugin.each{|equip|
      count += 1 if equip == item_id
    }
    return count
  end
  # アイテムリストの作成
  def make_item_list
    @itemlist = []
    $player.plugin_list.each{|plugin|
      if include?(plugin[0])
        plugin << Data_Plugin.name(plugin[0])
        @itemlist << plugin
      end
    }
    @itemlist.unshift(nil) unless @itemlist.empty?
  end
  # 項目の描画
  def draw_item(index, rect_x, rect_y)
    if @itemlist.empty?
      draw_text(x, rect_y, "\\C[9]プラグインがありません")
      return
    end
    if @itemlist[index].nil?
      draw_text(rect_x, rect_y, "\\C[9]プラグインを外す")
    else
      @quantity = @itemlist[index][1] - equip_count(@itemlist[index][0])
      character = enabled?(@itemlist[index][0]) ? "\\C[0]" : "\\C[9]"
      draw_text(rect_x, rect_y, character + @itemlist[index][2])
      draw_text(rect_x+237, rect_y, character + sprintf("×%2d", @quantity))
    end
  end
  # 決定/キャンセル処理、画面切り替えを追加
  def process_handling
    super
    return call_handler(:switching) if Key.push?(K_A)
    return call_handler(:narrow) if Key.push?(K_S)
  end
  def item
    return nil if @itemlist.empty?
    return enabled?(@itemlist[@index][0]) ? @itemlist[@index][0] : nil
  end
  def status_window=(status_window)
    @status_window = status_window
  end
  # ヘルプテキスト更新
  def update_help
    if @itemlist.empty?
      @help_window.set_item(' ')
    else
      begin
        help = Data_Plugin.description(@itemlist[@index][0])
      rescue
        help = narrow? ? "選択した条件で絞り込み中" : nil
      end
      @help_window.set_item(help.nil? ? ' ' : help)
      begin
        @status_window.set_buff([@itemlist[@index][0]],[Data_Plugin.buffs(@itemlist[@index][0])],[@slot_window.index])
      rescue
        @status_window.set_buff([nil],[nil],[@slot_window.index])
      end
    end
  end
  # 絞り込み中か
  def narrow?
    return true if $system.plugin_narrow[:hla] != 0
    return true if $system.plugin_narrow[:skill] != 0
    return true if $system.plugin_narrow[:org] != 0
    return true if $system.plugin_narrow[:sp] != 0
    return true if $system.plugin_narrow[:tec] != 0
    return true if $system.plugin_narrow[:mnd] != 0
    return true if $system.plugin_narrow[:agi] != 0
    return true if $system.plugin_narrow[:luk] != 0
    return true if $system.plugin_narrow[:atk] != 0
    return true if $system.plugin_narrow[:dfn] != 0
    return true if $system.plugin_narrow[:charm] != 0
    return true if $system.plugin_narrow[:palsy] != 0
    return true if $system.plugin_narrow[:rest] != 0
    return true if $system.plugin_narrow[:stan] != 0
    return false
  end
  # スロットウィンドウの設定
  def slot_window=(window)
    @slot_window = window
  end
end
