﻿#-----------------------------------------------------
# class Window_PluginNarrow
# プラグイン設定画面の絞り込みウィンドウを表示するウィンドウクラス。
#-----------------------------------------------------

class Window_PluginNarrow < Window_Selectable
  # 行の高さ
  def line_height
    return 25
  end
  # 桁数の取得
  def col_max
    return 2
  end
  # 項目数の最大値の取得
  def item_max
    return 16
  end
  # 項目の描画
  def draw_item(index, rect_x, rect_y)
    case index
    when 0    # HLAタイプ
      draw_text(rect_x, rect_y, "HLA：")
      text = Vocab::PluginProperty[:hla][$system.plugin_narrow[:hla]]
    when 1    # スキル取得
      draw_text(rect_x, rect_y, "スキル取得：")
      text = Vocab::PluginProperty[:skill][$system.plugin_narrow[:skill]]
    when 2    # ORG
      draw_text(rect_x, rect_y, "ORG：")
      text = Vocab::PluginProperty[:status][$system.plugin_narrow[:org]]
    when 3    # SP
      draw_text(rect_x, rect_y, "SP ：")
      text = Vocab::PluginProperty[:status][$system.plugin_narrow[:sp]]
    when 4    # TEC
      draw_text(rect_x, rect_y, "TEC：")
      text = Vocab::PluginProperty[:status][$system.plugin_narrow[:tec]]
    when 5    # MND
      draw_text(rect_x, rect_y, "MND：")
      text = Vocab::PluginProperty[:status][$system.plugin_narrow[:mnd]]
    when 6    # AGI
      draw_text(rect_x, rect_y, "AGI：")
      text = Vocab::PluginProperty[:status][$system.plugin_narrow[:agi]]
    when 7    # LUK
      draw_text(rect_x, rect_y, "LUK：")
      text = Vocab::PluginProperty[:status][$system.plugin_narrow[:luk]]
    when 8    # ATK
      draw_text(rect_x, rect_y, "ATK：")
      text = Vocab::PluginProperty[:status][$system.plugin_narrow[:atk]]
    when 9    # DEF
      draw_text(rect_x, rect_y, "DEF：")
      text = Vocab::PluginProperty[:status][$system.plugin_narrow[:dfn]]
    when 10   # 魅了確率
      draw_text(rect_x, rect_y, "魅了確率：")
      text = Vocab::PluginProperty[:state][$system.plugin_narrow[:charm]]
    when 11    # 麻痺確率
      draw_text(rect_x, rect_y, "麻痺確率：")
      text = Vocab::PluginProperty[:state][$system.plugin_narrow[:palsy]]
    when 12    # 拘束確率
      draw_text(rect_x, rect_y, "拘束確率：")
      text = Vocab::PluginProperty[:state][$system.plugin_narrow[:rest]]
    when 13    # スタン確率
      draw_text(rect_x, rect_y, "スタン確率：")
      text = Vocab::PluginProperty[:state][$system.plugin_narrow[:stan]]
    when 14    # AND OR
      draw_text(rect_x, rect_y, "絞り込み方式：")
      text = Vocab::PluginProperty[:a_o][$system.plugin_narrow[:a_o]]
    when 15   # 絞り込み解除
      draw_text(rect_x, rect_y, "絞り込み解除")
      text = ""
    end
    draw_text(rect_x+200, rect_y, sprintf("%s", text))
  end
  # 決定ハンドラの呼び出し
  def process_ok
    case index
    when 0
      $system.plugin_narrow[:hla] += 1
      $system.plugin_narrow[:hla] = 0 if $system.plugin_narrow[:hla] >= Vocab::PluginProperty[:hla].size
    when 1
      $system.plugin_narrow[:skill] += 1
      $system.plugin_narrow[:skill] = 0 if $system.plugin_narrow[:skill] >= Vocab::PluginProperty[:skill].size
    when 2
      $system.plugin_narrow[:org] += 1
      $system.plugin_narrow[:org] = 0 if $system.plugin_narrow[:org] >= Vocab::PluginProperty[:status].size
    when 3
      $system.plugin_narrow[:sp] += 1
      $system.plugin_narrow[:sp] = 0 if $system.plugin_narrow[:sp] >= Vocab::PluginProperty[:status].size
    when 4
      $system.plugin_narrow[:tec] += 1
      $system.plugin_narrow[:tec] = 0 if $system.plugin_narrow[:tec] >= Vocab::PluginProperty[:status].size
    when 5
      $system.plugin_narrow[:mnd] += 1
      $system.plugin_narrow[:mnd] = 0 if $system.plugin_narrow[:mnd] >= Vocab::PluginProperty[:status].size
    when 6
      $system.plugin_narrow[:agi] += 1
      $system.plugin_narrow[:agi] = 0 if $system.plugin_narrow[:agi] >= Vocab::PluginProperty[:status].size
    when 7
      $system.plugin_narrow[:luk] += 1
      $system.plugin_narrow[:luk] = 0 if $system.plugin_narrow[:luk] >= Vocab::PluginProperty[:status].size
    when 8
      $system.plugin_narrow[:atk] += 1
      $system.plugin_narrow[:atk] = 0 if $system.plugin_narrow[:atk] >= Vocab::PluginProperty[:status].size
    when 9
      $system.plugin_narrow[:dfn] += 1
      $system.plugin_narrow[:dfn] = 0 if $system.plugin_narrow[:dfn] >= Vocab::PluginProperty[:status].size
    when 10
      $system.plugin_narrow[:charm] += 1
      $system.plugin_narrow[:charm] = 0 if $system.plugin_narrow[:charm] >= Vocab::PluginProperty[:state].size
    when 11
      $system.plugin_narrow[:palsy] += 1
      $system.plugin_narrow[:palsy] = 0 if $system.plugin_narrow[:palsy] >= Vocab::PluginProperty[:state].size
    when 12
      $system.plugin_narrow[:rest] += 1
      $system.plugin_narrow[:rest] = 0 if $system.plugin_narrow[:rest] >= Vocab::PluginProperty[:state].size
    when 13
      $system.plugin_narrow[:stan] += 1
      $system.plugin_narrow[:stan] = 0 if $system.plugin_narrow[:stan] >= Vocab::PluginProperty[:state].size
    when 14
      $system.plugin_narrow[:a_o] += 1
      $system.plugin_narrow[:a_o] = 0 if $system.plugin_narrow[:a_o] >= Vocab::PluginProperty[:a_o].size
    when 15
      $system.plugin_narrow[:hla] = 0
      $system.plugin_narrow[:skill] = 0
      $system.plugin_narrow[:org] = 0
      $system.plugin_narrow[:sp] = 0
      $system.plugin_narrow[:tec] = 0
      $system.plugin_narrow[:mnd] = 0
      $system.plugin_narrow[:agi] = 0
      $system.plugin_narrow[:luk] = 0
      $system.plugin_narrow[:atk] = 0
      $system.plugin_narrow[:dfn] = 0
      $system.plugin_narrow[:charm] = 0
      $system.plugin_narrow[:palsy] = 0
      $system.plugin_narrow[:rest] = 0
      $system.plugin_narrow[:stan] = 0
      $system.plugin_narrow[:a_o] = 0
    end
    super
    refresh
  end
  # カーソルを下に移動
  def cursor_down
    if row < row_max - 1
      select(@index + col_max)
    else
      select(0)
    end
  end
  # カーソルを上に移動
  def cursor_up
    if row + 1 > 1
      select(@index - col_max)
    else
      select(item_max)
    end
  end
  # ヘルプウィンドウの更新
  def update_help
    case index
      when 0; @help_window.set_text("HLAで絞り込みます\nH+→H-→L+→L-→A+→A-→属性なし")
      when 1; @help_window.set_text("スキルを取得するプラグインで絞り込みます")
      when 2; @help_window.set_text("ORGを変動させるプラグインで絞り込みます")
      when 3; @help_window.set_text("SPを変動させるプラグインで絞り込みます")
      when 4; @help_window.set_text("TECを変動させるプラグインで絞り込みます")
      when 5; @help_window.set_text("MNDを変動させるプラグインで絞り込みます")
      when 6; @help_window.set_text("AGIを変動させるプラグインで絞り込みます")
      when 7; @help_window.set_text("LUKを変動させるプラグインで絞り込みます")
      when 8; @help_window.set_text("ATKを変動させるプラグインで絞り込みます")
      when 9; @help_window.set_text("DEFを変動させるプラグインで絞り込みます")
      when 10; @help_window.set_text("魅了確率を変動させるプラグインで絞り込みます")
      when 11; @help_window.set_text("麻痺確率を変動させるプラグインで絞り込みます")
      when 12; @help_window.set_text("拘束確率を変動させるプラグインで絞り込みます")
      when 13; @help_window.set_text("スタン確率を変動させるプラグインで絞り込みます")
      when 14; @help_window.set_text("絞り込み方式を変更します")
      when 15; @help_window.set_text("絞り込みをすべて解除します")
    end
  end
end
