#-----------------------------------------------------
# class Window_SetBattleBK
# 戦闘シミュの戦闘背景設定ウィンドウを表示するウィンドウクラス。
#-----------------------------------------------------

class Window_SetBattleBK < Window_Selectable
  # 初期化
  def initialize(x, y, width, height)
    super(x, y, width, height)
    @list = []
    make_list
  end
  # 行の高さ
  def line_height
    return 33
  end
  # 項目数の最大値の取得
  def item_max
    return Data_BattleBK.number
  end
  # コマンドリストの作成
  def make_list
    item_max.times{|n| @list << Data_BattleBK.name(n)}
  end
  # 項目の描画
  def draw_item(index, rect_x, rect_y)
    text = @list[index]
    text = "\\C[3]" + text if index == $system.battle_bk
    draw_text(rect_x, rect_y, text)
  end
  # フォーカス中のパスを取得
  def item
    return @index
  end
  # カーソルを下に移動
  def cursor_down
    if row < row_max - 1
      select(@index + col_max)
    else
      select(0)
    end
  end
  # カーソルを上に移動
  def cursor_up
    if row + 1 > 1
      select(@index - col_max)
    else
      select(item_max)
    end
  end
  # 背景スプライトの取得
  def set_bk_sprite(sprite)
    @sprite = sprite
  end
  # ヘルプウィンドウの更新
  def update_help
    unless @sprite.nil?
      if @index == 0
        @sprite.image = nil
      else
        pis = Pis.load($game_directory + '/data/img/battle/' + @index.to_s + '.pis')
        @sprite.image = pis[0]
      end
    end
    @help_window.set_text("戦闘シミュレータの背景を設定します")
  end
  # 解放処理
  def dispose
    @sprite.image.dispose unless @sprite.image.nil?
    @sprite.dispose
    @sprite.vanish
    @sprite = nil
  end
end
