#-----------------------------------------------------
# module Vocab
# ゲーム内で使用される用語やメッセージを定義するモジュール。
# RPGMaker Scriptsよりとりあえず全て引用。
#-----------------------------------------------------
module Vocab
  # 戦闘基本メッセージ
  Tutorial        = "チュートリアルバトルです。説明を見ますか？"
  Emerge          = "%sが現れた！"
  PosChange       = "%sは体勢を入れ替えた！"
  BreakWear       = "%sは相手の服をはぎとった！"
  DestroyWear     = "%sの装甲を破壊した！"
  DestroyWearToPosChange = "装甲を破壊された%sは体位を変えようと試みる！"
  BreakWearFailed = "しかし%sの手は振り払われた！"
  NoWear          = "すでに服を着ていない！"
  BreakPant       = "%sは相手のパンツをはぎとった！"
  BreakPantFailed = "しかし%sの手は振り払われた！"
  NoPant          = "すでにパンツをはいていない！"
  ReleaseBind     = "%sの拘束を解いた！"
  FailureReleaseBind = "%sの拘束を解けなかった！"

  # 戦闘終了メッセージ
  Victory         = "%sを絶頂させた！"
  Defeat          = "%sは戦いに敗れた。"
  ObtainItem      = "%sを手に入れた！"
  LevelUp         = "%sはレベル %d にレベルアップした！"
  ObtainSkill     = "%sを覚えた！"

  # アイテム使用
  UseItem         = "%sは%sを使った！"

  # アクター対象の行動結果
  ActorDamage     = "%sは %d のダメージを受けた！"
  ActorRecovery   = "%sの%sが %d 回復した！"
  ActorGain       = "%sの%sが %d 増えた！"
  ActorLoss       = "%sの%sが %d 減った！"
  ActorDrain      = "%sは%sを %d 奪われた！"
  ActorNoDamage   = "%sはダメージを受けていない！"
  ActorNoHit      = "ミス！　%sはダメージを受けていない！"

  # 敵キャラ対象の行動結果
  EnemyDamage     = "%sに %d のダメージを与えた！"
  EnemyRecovery   = "%sの%sが %d 回復した！"
  EnemyGain       = "%sの%sが %d 増えた！"
  EnemyLoss       = "%sの%sが %d 減った！"
  EnemyDrain      = "%sの%sを %d 奪った！"
  EnemyNoDamage   = "%sにダメージを与えられない！"
  EnemyNoHit      = "ミス！　%sにダメージを与えられない！"

  # 装甲対象の行動結果
  ArmorDamage     = "%sの装甲に %d のダメージを与えた！"
  ArmorRecovery   = "%sの装甲が %d 回復した！"
  ArmorGain       = "%sの%sが %d 増えた！"
  ArmorLoss       = "%sの%sが %d 減った！"
  ArmorDrain      = "%sの%sを %d 奪った！"
  ArmorNoDamage   = "%sの装甲にダメージを与えられない！"
  ArmorNoHit      = "ミス！　%sにダメージを与えられない！"

  # 能力強化／弱体
  BuffAdd         = "%sの%sが上がった！"
  DebuffAdd       = "%sの%sが下がった！"
  BuffRemove      = "%sの%sが元に戻った！"
  BuffNoRemove    = "%sの%sは変わっていない。"

  # スキル、アイテムの効果がなかった
  ActionNoResult  = "しかし何も効果がなかった！"

  # エラーメッセージ
  PlayerPosError  = "プレイヤーの初期位置が設定されていません。"

  # 戦闘シミュ操作説明メッセージ
  BattleSimuGuide = 'Aキー：お気に入り　Sキー：絞り込み　Dキー：背景変更'

  # 回想端末操作説明メッセージ
  RecRoomGuide = 'Aキー：お気に入り　Sキー：絞り込み'

  # リマインドモード切替メッセージ
  RemindModeGuide = 'Sキー：リマインドモード切り替え'

  # マップ選択モード切替メッセージ
  MapSelectGuide = 'Sキー：マップ選択モード切り替え'

  # 敵属性のハッシュ配列
  EnemyProperty = {
    play: [
      "すべて",
      "騎乗位",
      "バック",
      "正常位",
      "手コキ",
      "足コキ",
      "その他コキ系",
      "フェラチオ",
      "パイズリ"
    ],
    sub: [
      "すべて",
      "キス",
      "顔面騎乗",
      "授乳",
      "道具系",
      "拘束",
      "誘い受け",
      "逆アナル",
      "複数プレイ",
      "アブノーマル"
    ],
    age: [
      "すべて",
      "ロリ",
      "同年代",
      "お姉さん"
    ],
    hair: [
      "すべて",
      "ロング",
      "ショート",
      "ポニテ",
      "ツインテ"
    ],
    bust: [
      "すべて",
      "貧乳",
      "普乳",
      "巨乳"
    ],
    clothes: [
      "すべて",
      "制服系",
      "職業系",
      "私服系",
      "兵士",
      "コスプレ"
    ],
    socks: [
      "すべて",
      "ニーソックス",
      "ソックス",
      "タイツ",
      "素足",
      "ブーツ"
    ],
    accessory: [
      "すべて",
      "眼鏡",
      "帽子",
      "手袋",
      "武器"
    ],
    race: [
      "すべて",
      "人間",
      "アニマロイド",
      "機械"
    ],
    hla: [
      "すべて",
      "H型",
      "L型",
      "A型",
      "ノーマル"
    ],
    mode: [
      "すべて",
      "性技戦闘のみ",
      "物理戦闘あり",
      "イベント",
      "敗北エンド"
    ]
  }
  # プラグイン属性のハッシュ配列
  PluginProperty = {
    hla: ["-", "H+", "H-", "L+", "L-", "A+", "A-", "属性なし"],
    skill: ["-", "あり", "なし"],
    status: ["-", "増加", "減少"],
    state: ["-",  "減少", "増加"],
    a_o: ["AND", "OR"],
  }
  # プラグインプリセット操作説明
  PresetGuide = 'Aキー：個別設定'
  # プラグイン個別設定操作説明
  OnesetGuide = 'Sキー：絞り込み　Aキー：プリセット設定'
  # 能力値
  def self.param(param_id)
    case param_id
    when 0 ; return "ORG"
    when 1 ; return "SP"
    when 2 ; return "TEC"
    when 3 ; return "MND"
    when 4 ; return "AGI"
    when 5 ; return "LUK"
    when 6 ; return "ATK"
    when 7 ; return "DEF"
    end
  end
end
